import type * as ts from 'typescript';
export declare type Ast = ReturnType<typeof parse>;
export interface TextRange {
    start: number;
    end: number;
}
export declare function parse(ts: typeof import('typescript'), content: string, lang: string): {
    labels: (TextRange & {
        binarys: {
            parent: TextRange;
            vars: (TextRange & {
                isShortand: boolean;
                inRoot: boolean;
            })[];
            left: TextRange;
            right: undefined | (TextRange & {
                isComputedCall: boolean;
                withoutAs: TextRange;
                as: undefined | TextRange;
            });
        }[];
        label: TextRange;
        parent: TextRange;
    })[];
    bindings: TextRange[];
    dollars: number[];
    withDefaultsArg: TextRange | undefined;
    propsRuntimeArg: TextRange | undefined;
    propsTypeArg: TextRange | undefined;
    emitsRuntimeArg: TextRange | undefined;
    emitsTypeArg: TextRange | undefined;
};
export declare function collectBindings(ts: typeof import('typescript'), sourceFile: ts.SourceFile): TextRange[];
export declare function parse2(ts: typeof import('typescript'), content: string, lang: string): {
    refCalls: (TextRange & {
        vars: TextRange[];
        left: TextRange;
        rightExpression: undefined | TextRange;
        rightType: undefined | TextRange;
    })[];
    shorthandPropertys: TextRange[];
};
export declare function getStartEnd(node: ts.Node, sourceFile: ts.SourceFile): {
    start: number;
    end: number;
};
