"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
function register({ sourceFiles, tsLs }) {
    return (uri, position) => {
        const sourceFile = sourceFiles.get(uri);
        if (!sourceFile)
            return;
        const tsResult = getTsResult(sourceFile);
        if (tsResult)
            return tsResult;
        function getTsResult(sourceFile) {
            for (const sourceMap of sourceFile.getTsSourceMaps()) {
                for (const tsRange of sourceMap.getMappedRanges(position)) {
                    if (!tsRange.data.capabilities.basic)
                        continue;
                    const result = tsLs.getSignatureHelp(sourceMap.mappedDocument.uri, tsRange.start);
                    if (result) {
                        return result; // TODO: to array
                    }
                }
            }
        }
    };
}
exports.register = register;
//# sourceMappingURL=signatureHelp.js.map